Irrlicht Engine: irr::gui::IGUIElementFactory Class Reference

Home | Namespaces | Hierarchy | Alphabetical List | Class list | Files | Namespace Members | Class members | File members | Tutorials

# irr::gui::IGUIElementFactory Class Reference

Interface making it possible to dynamically create GUI elements. More...

`#include <IGUIElementFactory.h>`

Inheritance diagram for irr::gui::IGUIElementFactory:

List of all members.

## Public Member Functions
virtual IGUIElement * | addGUIElement (const c8 *typeName, IGUIElement *parent=0)=0
| adds a GUI element to the GUI Environment based on its type name
virtual IGUIElement * | addGUIElement (EGUI_ELEMENT_TYPE type, IGUIElement *parent=0)=0
| adds an element to the gui environment based on its type id
virtual s32 | getCreatableGUIElementTypeCount () const =0
| Get amount of GUI element types this factory is able to create.
virtual EGUI_ELEMENT_TYPE | getCreateableGUIElementType (s32 idx) const =0
| Get type of a createable element type.
virtual const c8 * | getCreateableGUIElementTypeName (EGUI_ELEMENT_TYPE type) const =0
| returns type name of a createable GUI element
virtual const c8 * | getCreateableGUIElementTypeName (s32 idx) const =0
| Get type name of a createable GUI element type by index.

## Detailed Description

Interface making it possible to dynamically create GUI elements.

To be able to add custom elements to Irrlicht and to make it possible for the scene manager to save and load them, simply implement this interface and register it in your gui environment via IGUIEnvironment::registerGUIElementFactory. Note: When implementing your own element factory, don't call IGUIEnvironment::grab() to increase the reference counter of the environment. This is not necessary because the it will grab() the factory anyway, and otherwise cyclic references will be created.

Definition at line 26 of file IGUIElementFactory.h.

## Member Function Documentation

virtual IGUIElement* irr::gui::IGUIElementFactory::addGUIElement | ( | const c8 * | typeName,
|  | IGUIElement * | parent = `0` |
| ) |  |  | `[pure virtual]`

adds a GUI element to the GUI Environment based on its type name

Parameters:

  | typeName,: | Type name of the element to add.
  | parent,: | Parent scene node of the new element, can be null to add it to the root.

Returns:
  Pointer to the new element or null if not successful.

virtual IGUIElement* irr::gui::IGUIElementFactory::addGUIElement | ( | EGUI_ELEMENT_TYPE | type,
|  | IGUIElement * | parent = `0` |
| ) |  |  | `[pure virtual]`

adds an element to the gui environment based on its type id

Parameters:

  | type,: | Type of the element to add.
  | parent,: | Parent scene node of the new element, can be null to add to the root.

Returns:
  Pointer to the new element or null if not successful.

virtual s32 irr::gui::IGUIElementFactory::getCreatableGUIElementTypeCount | ( |  | ) | const`[pure virtual]`

Get amount of GUI element types this factory is able to create.

virtual EGUI_ELEMENT_TYPE irr::gui::IGUIElementFactory::getCreateableGUIElementType | ( | s32 | idx | ) | const`[pure virtual]`

Get type of a createable element type.

Parameters:

  | idx,: | Index of the element type in this factory. Must be a value between 0 and getCreatableGUIElementTypeCount()

virtual const c8* irr::gui::IGUIElementFactory::getCreateableGUIElementTypeName | ( | EGUI_ELEMENT_TYPE | type | ) | const`[pure virtual]`

returns type name of a createable GUI element

Parameters:

  | type,: | Type of GUI element.

Returns:
  Name of the type if this factory can create the type, otherwise 0.

virtual const c8* irr::gui::IGUIElementFactory::getCreateableGUIElementTypeName | ( | s32 | idx | ) | const`[pure virtual]`

Get type name of a createable GUI element type by index.

Parameters:

  | idx,: | Index of the type in this factory. Must be a value between 0 and getCreatableGUIElementTypeCount()

The documentation for this class was generated from the following file:

- IGUIElementFactory.h

| The Irrlicht Engine Documentation © 2003-2010 by Nikolaus Gebhardt. Generated on Sun Oct 24 12:42:04 2010 by Doxygen (1.6.2)